<ng-container *ngIf="{ categories: config?.categories$ | async } as vm">
  <ng-content select=".drag-placeholder"></ng-content>
  <ng-content select=".drag-handler"></ng-content>
  <form
    class="member"
    *ngIf="formGroup && config"
    [formGroup]="formGroup"
    #form="ngForm" (ngSubmit)="formGroup.value.showManual ? submitManualForm($event) : submitAutoForm($event) ; formGroup.valid && onMemberValidate()">

    <mat-drawer-container *ngIf="{ opened: false } as drawerVm"
                          [class.manual]="formGroup.value.showManual"
                          [class.with-category]="config.labelKeys.category | translateHasKey"
                          [class.opened]="drawerVm.opened">
      <mat-drawer [opened]="!formGroup.value.hideForm"
                  (openedStart)="drawerVm.opened = true" (closed)="drawerVm.opened = false"
                  mode="side" disableClose>
        <span *ngIf="index > -1" class="number">
          {{ index + 1 }}
        </span>

        <ng-template #auto>
          <form ngForm [formGroup]="formGroups.auto"
                class="member-form">
            <mat-form-field>
              <mat-label>
                {{ config.labelKeys.member | translate }}
              </mat-label>
              <input matInput
                     formControlName="member"
                     [matAutocomplete]="auto">
              <mat-autocomplete #auto="matAutocomplete" [displayWith]="memberDisplay"
                                (optionSelected)="onMemberSelected()">
                <mat-option *ngFor="let member of formGroup.value.auto?.members$ | async; trackBy: trackBySlug"
                            class="member"
                            [value]="member">
                  <span>
                    {{ member.firstName }} {{ member.lastName }}
                  </span>
                  <small>
                    {{ member.code | number:'7.0-0':'fr-FR' }}
                    <ng-container *ngIf="'common.category.' + member.category | translateHasKey">
                      -
                      <strong>
                        {{ 'common.category.' + member.category | translate }}
                      </strong>
                    </ng-container>
                  </small>
                </mat-option>
              </mat-autocomplete>
              <mat-error *ngIf="formGroups.auto.controls.member.errors?.required">
                {{ 'admin.common.validation.required' | translate }}
              </mat-error>
            </mat-form-field>
          </form>
        </ng-template>

        <ng-template #manual>
          <form ngForm [formGroup]="formGroups.manual"
                class="member-form manual">
            <mat-form-field>
              <mat-label>
                {{ config.labelKeys.firstName | translate }}
              </mat-label>
              <input matInput
                     name="firstName" formControlName="firstName"/>
              <mat-error *ngIf="formGroups.manual.controls.firstName.errors?.required">
                {{ 'admin.common.validation.required' | translate }}
              </mat-error>
            </mat-form-field>
            <mat-form-field>
              <mat-label>
                {{ config.labelKeys.lastName | translate }}
              </mat-label>
              <input matInput
                     name="lastName" formControlName="lastName"/>
              <mat-error *ngIf="formGroups.manual.controls.lastName.errors?.required">
                {{ 'admin.common.validation.required' | translate }}
              </mat-error>
            </mat-form-field>
            <mat-form-field>
              <mat-label>
                {{ config.labelKeys.code | translate }}
              </mat-label>
              <input matInput type="number"
                     name="code" formControlName="code"/>
              <mat-error *ngIf="formGroups.manual.controls.code.errors?.required">
                {{ 'admin.common.validation.required' | translate }}
              </mat-error>
            </mat-form-field>
            <mat-form-field *ngIf="config.labelKeys.category | translateHasKey">
              <mat-label>
                {{ config.labelKeys.category | translate }}
              </mat-label>
              <mat-select formControlName="category">
                <mat-option *ngFor="let category of vm.categories; trackBy: trackBySlug"
                            [value]="category">
                  {{ 'common.category.' + category | translate }}
                </mat-option>
              </mat-select>
              <mat-error *ngIf="formGroups.manual.controls.category.errors?.required">
                {{ 'admin.common.validation.required' | translate }}
              </mat-error>
            </mat-form-field>
          </form>
        </ng-template>

        <ng-container *ngIf="formGroup.value.showManual then manual; else auto"></ng-container>

        <button type="button" mat-icon-button class="switch"
                (click)="resetValues(true); switchManualRequiredValidator(formGroup.value.showManual)"
                angulartics2On="click"
                [angularticsLabel]="config.analyticsLabel"
                angularticsAction="toggle"
                angularticsCategory="fmi-team">
          <mat-icon>
            {{ formGroup.value.showManual ? 'keyboard_backspace' : 'help' }}
          </mat-icon>
        </button>

        <ng-template #validate>
          <button mat-icon-button class="status"
                  angulartics2On="click"
                  [angularticsLabel]="config.analyticsLabel"
                  angularticsAction="valid"
                  angularticsCategory="fmi-team">
            <mat-icon>
              done
            </mat-icon>
          </button>
        </ng-template>

        <ng-template #delete>
          <button type="button" mat-icon-button class="status"
                  (click)="deleteGroup()"
                  angulartics2On="click"
                  [angularticsLabel]="config.analyticsLabel"
                  angularticsAction="delete"
                  angularticsCategory="fmi-team">
            <mat-icon>
              delete
            </mat-icon>
          </button>
        </ng-template>

        <ng-container *ngIf="formGroup.value.showManual ? formGroup.controls.manual?.valid : formGroup.controls.auto?.valid then validate; else delete"></ng-container>

      </mat-drawer>
      <mat-drawer-content>
        <ng-container>
          <span *ngIf="index > -1" class="number">
            {{ index + 1 }}
          </span>
          <article *ngIf="formGroup.value.auto?.member || formGroup.value.manual as member">
            <h5>
              {{ member.firstName }} {{ member.lastName }}
            </h5>
            <span class="license-wrapper">
              <small>
                {{ member.code | licenseNumber }}
              </small>

              <mat-icon *ngIf="!member.slug"
                        [matTooltip]="'fmi.team.form.manual' | translate"
                        matTooltipPosition="above">
                warning
              </mat-icon>
            </span>
            <small *ngIf="config.labelKeys.category | translateHasKey">
              <strong *ngIf="'common.category.' + member.category | translateHasKey">
                {{ 'common.category.' + member.category | translate }}
              </strong>
            </small>
          </article>
          <button type="button" mat-icon-button class="edit"
                  (click)="formGroup.controls.hideForm.patchValue(false)"
                  angulartics2On="click"
                  [angularticsLabel]="config.analyticsLabel"
                  angularticsAction="edit"
                  angularticsCategory="fmi-team">
            <mat-icon>
              edit
            </mat-icon>
          </button>
          <button type="button" mat-icon-button class="delete"
                  (click)="deleteGroup()"
                  angulartics2On="click"
                  [angularticsLabel]="config.analyticsLabel"
                  angularticsAction="delete"
                  angularticsCategory="fmi-team">
            <mat-icon>
              delete
            </mat-icon>
          </button>
        </ng-container>
      </mat-drawer-content>
    </mat-drawer-container>
  </form>
</ng-container>
